/*
 * out_yasapi.c
 * Copyright (C) 2015-2016 Peter Belkner <pbelkner@snafu.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#if 0 // {
#include <windows.h>
#include <shlobj.h>
#include "../winamp/out.h"

#define PI_VER2 "v1.11 beta"

#ifdef __alpha
#define PI_VER PI_VER2 " (AXP)"
#else
#define PI_VER PI_VER2 " (x86)"
#endif
#else // } {
#include <yasapi.h>
#endif // }

#define GetTime(time) \
  (bAudioClock?time:GetTickCount())
#define PlayerIsUnderfow(pPlayer) \
  (PLAYER_STATE_UNDERFLOW==(pPlayer)->state)
#define PlayerHasChanged(pPlayer) \
  strcmp((pPlayer)->base.pszFileName,module)

int getwrittentime();
int getoutputtime();

int srate, numchan, bps, active;
volatile int64_t writtentime, w_offset;
int64_t start_t;
static int last_pause=0;
static int ref_true=1;

static wchar_t *path;
static PlayerDevice device;
static Player player;
static int bAudioClock;
#if defined (YASAPI_GAPLESS) // {
static int bReset;
#endif // }

#if defined (YASAPI_GAPLESS) // {
#define OUT_YASAPI_SUBCLASS
#endif // }

static int PlayerSendOpen(int srate, int numchan, int bps)
{
#if 0 // {
  int bPause=0;

#if defined (YASAPI_NOTIFY) // {
  return PlayerSend(&player,0,PlayerOpen,&device,srate,numchan,bps,NULL);
#else // } {
  return PlayerSend(&player,0,PlayerOpen,&device,srate,numchan,bps);
#endif // }
#else // } {
  return PlayerSend(&player,0,PlayerOpen,&device,srate,numchan,bps);
#endif // }
}

static int PlayerSendClose(void)
{
#if 0 // {
#if defined (YASAPI_NOTIFY) // {
   return PlayerSend(&player,0,PlayerClose,NULL);
#else // } {
   return PlayerSend(&player,0,PlayerClose);
#endif // }
#else // } {
   return PlayerSend(&player,0,PlayerClose);
#endif // }
}

#if defined (OUT_YASAPI_SUBCLASS) // {
static WNDPROC WinampProc;

static LRESULT CALLBACK PluginWinampProc(HWND hWnd, UINT uMsg, WPARAM wParam,
    LPARAM lParam)
{
  char *module;

  switch (uMsg) {
  case WM_WA_IPC:
    switch (lParam) {
    case IPC_CB_OUTPUTCHANGED:
      module=(char *)SendMessage(hWnd,WM_WA_IPC,0,IPC_GETOUTPUTPLUGIN);
      DPRINTF(0,"  WM_WA_IPC/IPC_CB_OUTPUTCHANGED: \"%s\"\n",module);

      if (PlayerIsUnderfow(&player)&&PlayerHasChanged(&player))
        PlayerSendClose();

      break;
    default:
      break;
    }

    break;
  default:
    break;
  }

  return CallWindowProc(
    WinampProc,   // _In_ WNDPROC lpPrevWndFunc,
    hWnd,         // _In_ HWND    hWnd,
    uMsg,         // _In_ UINT    Msg,
    wParam,       // _In_ WPARAM  wParam,
    lParam        // _In_ LPARAM  lParam
  );
}

static int SubclassWinamp(HWND hWnd)
{
  if (NULL==hWnd||NULL!=WinampProc) {
    DMESSAGE("failing to subclass winamp window");
    return -1;
  }

  WinampProc=(WNDPROC)SetWindowLong(
    hWnd,                   // _In_ HWND hWnd,
    GWL_WNDPROC,            // _In_ int  nIndex,
    (LONG)PluginWinampProc  // _In_ LONG dwNewLong
  );

  return 0;
}

static int UnsubclassWinamp(HWND hWnd)
{
  if (NULL==hWnd||NULL==WinampProc) {
    DMESSAGE("failing to unsubclass winamp window");
    return -1;
  }

  SetWindowLong(
    hWnd,                   // _In_ HWND hWnd,
    GWL_WNDPROC,            // _In_ int  nIndex,
    (LONG)WinampProc        // _In_ LONG dwNewLong
  );

  return 0;
}
#endif // }

#if 0 // {
BOOL WINAPI _DllMainCRTStartup(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
{
  return TRUE;
}

Out_Module out;
#endif // }

static int GetAudioTime(void)
{
  return player.state<PLAYER_STATE_PLAY
      ?0
      :PlayerSend(&player,0,PlayerGetTime);
}

void config(HWND hwnd)
{
  const Out_Module *mod=winampGetOutModule();

  DPRINTF(0,"%s\n",__func__);
  ConfigDialog(&player,mod->hDllInstance,hwnd);
}

void about(HWND hwnd)
{
#if defined (YASAPI_ABOUT) // {
  const Out_Module *mod=winampGetOutModule();
#endif // }

  DPRINTF(0,"%s\n",__func__);
#if defined (YASAPI_ABOUT) // {
  AboutDialog(&player,mod->hDllInstance,hwnd);
#else // } {
  AboutDialog(hwnd);
#endif // }
}

void init()
{
  const Out_Module *mod=winampGetOutModule();
#if defined (YASAPI_ABOUT) // {
  INITCOMMONCONTROLSEX iccx;
#endif // }
#if defined (YASAPI_CO_INITIALIZE) // {
  HRESULT hr;
#endif // }

#if defined (YASAPI_ABOUT) // {
  ZeroMemory(&iccx,sizeof iccx);
  iccx.dwSize=sizeof iccx;
  iccx.dwICC|=ICC_LINK_CLASS;
  InitCommonControls();
#endif // }

  if (NULL==(path=wapath(YASAPI_PROPERTY_FILE_NAME,mod->hMainWindow)))
    goto path;

#if defined (YASAPI_DEBUG) // {
  TraceCreate(&trace,PI_LABEL,path);
#endif // }

  DPRINTF(0,"%s (%s)\n",__func__,YASAPI_MODULE);
  DWPRINTF(0,L"  \"%s\"\n",path);

#if defined (YASAPI_CO_INITIALIZE) // {
  hr=CoInitializeEx(
    NULL,                     // _In_opt_ LPVOID pvReserved
    COINIT_MULTITHREADED      // _In_     DWORD  dwCoInit
  );

  if (FAILED(hr)) {
    DERROR(S_FALSE,hr);
    DERROR(RPC_E_CHANGED_MODE,hr);
    DMESSAGE("initializing com failed");
    goto com;
  }

  DPUTS(0,"  com initialized\n");
#endif // }

#if defined (OUT_YASAPI_SUBCLASS) // {
  if (SubclassWinamp(mod->hMainWindow)<0) {
    DMESSAGE("  failed to subclass winamp");
    goto subclass;
  }

  DPUTS(0,"  winamp subclassed\n");
#endif // }

  if (PlayerCreate(&player,mod->hDllInstance,path)<0) {
    DMESSAGE("creating player");
    goto player;
  }

  return;
//cleanup:
player:
#if defined (OUT_YASAPI_SUBCLASS) // {
  UnsubclassWinamp(mod->hMainWindow);
subclass:
#endif // }
#if defined (YASAPI_CO_INITIALIZE) // {
  CoUninitialize();
com:
#endif // }
  YASAPI_FREE(path);
path:
  return;
}

void quit()
{
  DPRINTF(0,"%s (%s)\n",__func__,player.base.pszFileName);
  PlayerDestroy(&player);
#if defined (OUT_YASAPI_SUBCLASS) // {
  DPUTS(0,"  unsubclassing winamp\n");
  UnsubclassWinamp(winampGetOutModule()->hMainWindow);
#endif // }
#if defined (YASAPI_CO_INITIALIZE) // {
  DPUTS(0,"  destroying com\n");
  CoUninitialize();
#endif // }
#if defined (YASAPI_DEBUG) // {
  TraceDestroy(&trace,trace.nSleep);
#endif // }
  YASAPI_FREE(path);
}

static void reset(void)
{
#if defined (YASAPI_SWITCH_PAUSE) // {
  int bPause=ref_true==last_pause;
#endif // }

  start_t = GetTime(0);
  w_offset = writtentime = 0;
#if defined (YASAPI_SWITCH_PAUSE) // {
  ref_true=!bPause;
#endif // }
  last_pause=!ref_true;
}

#if defined (YASAPI_GAPLESS) // {
static int drain(int numchan, int srate, int bps)
{
  bReset=0;

  if (PLAYER_STATE_RUN<player.state) {
    while (PlayerSend(&player,0,PlayerIsPlaying))
      Sleep(1);
  }

  PlayerSendClose();

  return PlayerSendOpen(srate,numchan,bps);
}
#endif // }

int open(int samplerate, int numchannels, int bitspersamp, int bufferlenms,
    int prebufferms)
{
#if defined (YASAPI_GAPLESS) // {
  int bGapless=player.options.common.bGapless;
  WAVEFORMATEXTENSIBLE *pwfxx=&player.open.wfxx;
  WAVEFORMATEX *pwfx=&pwfxx->Format;
  WORD wBitsPerSample=pwfx->wBitsPerSample;
  int nChannels=pwfx->nChannels;
  int nSamplesPerSec=pwfxx->Format.nSamplesPerSec;
  int bChange=0;
#endif // }

  DPRINTF(0,"%s (%s)\n",__func__,player.base.pszFileName);

  bAudioClock=player.options.common.bAudioClock;
  reset();

  active=1;
  numchan = numchannels;
  srate = samplerate;
  bps = bitspersamp;

  if (PlayerSend(&player,0,PlayerDeviceCreateV,&device)<0)
    return -1;

#if defined (YASAPI_GAPLESS) // {
  if (player.state<PLAYER_STATE_PAUSE)
    return PlayerSendOpen(srate,numchan,bps);
  else if (bGapless&&bReset) {
    bReset=0;

    bChange=bChange||wcscmp(device.szId,player.device.szId);
#if defined (YASAPI_SORROUND) // {
    bChange=bChange||player.options.common.bSorround!=player.open.bSorround;
#endif // }
    bChange=bChange||numchannels!=nChannels;
    bChange=bChange||samplerate!=nSamplesPerSec;
    bChange=bChange||bitspersamp!=wBitsPerSample;

    if (bChange)
      return drain(numchan,srate,bps);
    else {
      PlayerSend(&player,0,PlayerDeviceDestroyV,&device);

      return PlayerSend(&player,0,PlayerReset);
    }
  }
  else
    return drain(numchan,srate,bps);
#else // } {
  return PlayerSendOpen(srate,numchan,bps);
#endif // }
}

void close()
{
#if defined (YASAPI_GAPLESS) // {
  int bGapless=player.options.common.bGapless;
#if defined (YASAPI_CHECK_UNDERFLOW) // {
  int bDisconnect=player.options.common.bDisconnect;
#endif // }
#endif // }

  DPRINTF(0,"%s (%s)\n",__func__,player.base.pszFileName);
#if defined (YASAPI_GAPLESS) // {
  if (!bReset||!bGapless)
    PlayerSendClose();
#if defined (YASAPI_CHECK_UNDERFLOW) // {
  else if (bDisconnect)
    PlayerSetTimerCheckUnderflow(&player);
#endif // }
#else // } {
  PlayerSendClose();
#endif // }
}

int write(char *buf, int len)
{
#if 0 // {
  writtentime += len;
  return 0;
#else // } {
  int bPause=ref_true==last_pause;

  DPRINTF(3,"%s (%s)\n",__func__,player.base.pszFileName);

  if (!bPause&&PlayerSend(&player,0,PlayerWrite,buf,len)<0)
    return 1;
  else {
    writtentime+=len;
    return 0;
  }
#endif // }
}

int canwrite()
{
  int bPause=ref_true==last_pause;
  int bytes;

  DPRINTF(3,"%s (%s)\n",__func__,player.base.pszFileName);
  bytes=bPause?0:PlayerSend(&player,0,PlayerCanWrite);
  DPRINTF(3,"  bytes: %d\n",bytes);

  return bytes;
}

int isplaying()
{
#if defined (YASAPI_GAPLESS) // {
  int bGapless=player.options.common.bGapless;
#endif // }
  HWND hWnd=winampGetOutModule()->hMainWindow;
  char *module=(char *)SendMessage(hWnd,WM_WA_IPC,0,IPC_GETOUTPUTPLUGIN);
  int bPlaying;

  DPRINTF(0,"%s (%s)\n",__func__,player.base.pszFileName);
  DPRINTF(0,"  %s\n",module);

#if defined (YASAPI_GAPLESS) // {
  if (!bGapless||PlayerHasChanged(&player))
    bPlaying=PlayerSend(&player,0,PlayerIsPlaying);
  else {
    bReset=1;
    bPlaying=0;
  }
#else // } {
  bPlaying=PlayerSend(&player,0,PlayerIsPlaying);
#endif // }

#if 0 // }
  if (!bPlaying)
    reset();
#endif // }

  return bPlaying;
}

int pause(int pause)
{
#if 0 // {
  int t=last_pause;
  if (!last_pause && pause) { w_offset+=GetTickCount()-start_t;  writtentime=0; }
  if (last_pause && !pause) { start_t=GetTickCount(); }
  last_pause=pause;
  return t;
#else // } {
  int bPause=ref_true==pause;
  int t=last_pause;
  int time;

  DPRINTF(0,"%s (%s)\n",__func__,player.base.pszFileName);
  time=PlayerSend(&player,0,PlayerPause);

  if (bPause) {
    w_offset+=GetTime(time)-start_t;
    writtentime=0;
  }
  else
    start_t=GetTime(time);

  last_pause=pause;

  return t;
#endif // }
}

void setvolume(int volume)
{
  if (player.options.common.bVolume&&-666!=volume) {
    player.base.qVolume=255==volume?1.0:(double)volume/255;
    DPRINTF(0,"%s: %.2f\n",__func__,player.base.qVolume);
  }
}

void setpan(int pan)
{
}

void flush(int t)
{
  int time;
  
  DPRINTF(0,"%s\n",__func__);
  time=PlayerSend(&player,0,PlayerFlush);
  w_offset=t;
  start_t=GetTime(time);
  writtentime=0;
}
  
int getoutputtime()
{
#if 0 // {
  if (last_pause)
    return w_offset;
  return GetTickCount()-start_t + w_offset;
#else // } {
  int bPause=ref_true==last_pause;

  if (bPause)
    return w_offset;
  return GetTime(GetAudioTime())-start_t + w_offset;
#endif // }
}

int getwrittentime()
{
  int t=srate*numchan,l;
  int ms=writtentime;

  if (t) {
    l=ms%t;
    ms /= t;
    ms *= 1000;
    ms += (l*1000)/t;

    ms/=(bps/8);

    return ms + w_offset;
  }
  else
    return ms;
}

#if 0 // {
Out_Module out = {
  OUT_VER,
  "Nullsoft NULL Output Plug-In " PI_VER
  
  ,
  65,
  0, // hmainwindow
  0, // hdllinstance
  config,
  about,
  init,
  quit,
  open,
  close,
  write,
  canwrite,
  isplaying,
  pause,
  setvolume,
  setpan,
  flush,
  getoutputtime,
  getwrittentime
};

__declspec( dllexport ) Out_Module * winampGetOutModule()
{
  return &out;
}
#else // } {
__declspec( dllexport ) Out_Module * winampGetOutModule()
{
  static Out_Module out;

  if (0==out.version) {
    out.version
      // module version (OUT_VER)
      =OUT_VER;
    out.description
      // description of module, with version string
      =PI_LABEL;
    out.id
      // module id. each input module gets its own.
      // non-nullsoft modules should be >= 65536. 
      =YASAPI_WA_ID;
    out.hMainWindow
      // winamp's main window (filled in by winamp)
      =NULL;
    out.hDllInstance
      // DLL instance handle (filled in by winamp)
      =NULL;
    out.Config
      // configuration dialog 
      =config;
    out.About
      // about dialog
      =about;
    out.Init
      // called when loaded
      =init;
    out.Quit
      // called when unloaded
      =quit;
    out.Open
      // returns >=0 on success, <0 on failure
      //
      // NOTENOTENOTE: bufferlenms and prebufferms are ignored in most
      // if not all output plug-ins. 
      //    ... so don't expect the max latency returned to be what you
      // asked for.
      // returns max latency in ms (0 for diskwriters, etc)
      // bufferlenms and prebufferms must be in ms. 0 to use defaults. 
      // prebufferms must be <= bufferlenms
      // pass bufferlenms==-666 to tell the output plugin that it's clock
      // is going to be used to sync video
      // out_ds turns off silence-eating when -666 is passed
      =open;
    out.Close
      // close the ol' output device.
      =close;
    out.Write
      // 0 on success. Len == bytes to write (<= 8192 always). buf is
      //   straight audio data. 
      // 1 returns not able to write (yet). Non-blocking, always.
      =write;
    out.CanWrite
      // returns number of bytes possible to write at a given time. 
      // Never will decrease unless you call Write (or Close, heh)
      =canwrite;
    out.IsPlaying
      // non0 if output is still going or if data in buffers waiting to be
      // written (i.e. closing while IsPlaying() returns 1 would truncate
      // the song
      =isplaying;
    out.Pause
      // returns previous pause state
      =pause;
    out.SetVolume
      // volume is 0-255
      =setvolume;
    out.SetPan
      // pan is -128 to 128
      =setpan;
    out.Flush
      // flushes buffers and restarts output at time t (in ms) 
      // (used for seeking)
      =flush;
    out.GetOutputTime
      // returns played time in MS
      =getoutputtime;
    out.GetWrittenTime
      // returns time written in MS (used for synching up vis stuff)
      =getwrittentime;
  }

  return &out;
}
#endif // }
