/*
 * yasapi_debug.c
 * Copyright (C) 2015-2016 Peter Belkner <pbelkner@snafu.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <yasapi.h>
#include <stdarg.h>

int vmessage(const char *format, va_list ap)
{
  char buf[256],*wp=buf;
  int code;

  wp+=vsprintf(wp,format,ap);
  wp+=sprintf(wp,"Do you want to exit Winamp?");

  code=MessageBoxA(
    NULL,                       // _In_opt_  HWND hWnd,
    buf,                        // _In_opt_  LPCTSTR lpText,
    "YASAPI Error Message",     // _In_opt_  LPCTSTR lpCaption,
    MB_SYSTEMMODAL|MB_YESNO|MB_ICONERROR
                                // _In_      UINT uType
  );

  if (IDYES==code)
    exit(1);

  return wp-buf;
}

int message(int force, HRESULT x, HRESULT *y, const char *m, ...)
{
  va_list ap;

  if ((!force&&x==*y)||(force&&*y)) {
    va_start(ap,m);
#if defined (YASAPI_DEBUG) // {
    TRACE_CLOSE<trace.tag?tvprintf(&trace,m,ap):vmessage(m,ap);
#else // } {
    vmessage(m,ap);
#endif // }
    va_end(ap);
    *y=0;
  }

  return 0;
}

#if defined (YASAPI_DEBUG) // {
void ConsoleOpen(void)
{
  AllocConsole();
  freopen("conin$","r",stdin);
  freopen("conout$","w",stdout);
  freopen("conout$","w",stderr);
}

void ConsoleClose(void)
{
  FreeConsole();
}
#endif // }
