/*
 * yasapi_queue_read.c
 * Copyright (C) 2015-2016 Peter Belkner <pbelkner@snafu.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <yasapi.h>

///////////////////////////////////////////////////////////////////////////////
static HANDLE ReadGetSemaphoreDown(Queue *pQueue)
{
  return pQueue->hWritten;
}

static HANDLE ReadGetSemaphoreUp(Queue *pQueue)
{
  return pQueue->hAvailable;
}

static BOOL ReadIsAlertable(Queue *pQueue)
{
  return TRUE;
}

static Request **ReadGetRequest(Queue *pQueue)
{
  return &pQueue->rp;
}

const QueueStrategy cqsRead={
  "read",
  ReadGetSemaphoreDown,
  ReadGetSemaphoreUp,
  ReadIsAlertable,
  ReadGetRequest,
#if defined (YASAPI_DEBUG) // {
  QueueNopAvailable,
  QueueIncAvailable,
#endif // }
};
